{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": null,
   "id": "462edefb-fd43-4e72-b498-79b41c3db4ef",
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 100, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 50, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 90, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 100, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 70, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 50, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 10, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 100, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 150, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 180, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 200, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 225, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 200, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 200, \"pulse_width\": 150, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 150, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 0, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 100, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 200, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 200, \"channel\": \"CH1\"}\n",
      "\n",
      "Sending data by serial port: {\"frequency\": 80, \"pot_value\": 255, \"pulse_width\": 100, \"channel\": \"CH1\"}\n",
      "\n"
     ]
    }
   ],
   "source": [
    "import tkinter as tk\n",
    "import customtkinter as ctk\n",
    "from tkinter import messagebox\n",
    "import serial\n",
    "import serial.tools.list_ports\n",
    "import json\n",
    "import time\n",
    "\n",
    "class SerialMonitor(ctk.CTk):\n",
    "    def __init__(self):\n",
    "        super().__init__()\n",
    "        self.title(\"Settings of Multi Channel High Voltage Pulse Generator Board\")\n",
    "\n",
    "        # Crear menú desplegable para seleccionar el puerto COM\n",
    "        self.selected_port = tk.StringVar(self, value=\"\")\n",
    "        self.ports = self.list_ports()\n",
    "        self.port_menu = ctk.CTkOptionMenu(self, variable=self.selected_port, values=self.ports)\n",
    "        ctk.CTkLabel(self, text=\"Select COM Port:\").grid(row=0, column=0, padx=10, pady=10)\n",
    "        self.port_menu.grid(row=0, column=1, padx=10, pady=10)\n",
    "\n",
    "        # Crear el menú desplegable para seleccionar el canal\n",
    "        self.channel_var = tk.StringVar(self, value=\"CH1\")\n",
    "        self.channel_menu = ctk.CTkOptionMenu(self, variable=self.channel_var, values=[f\"CH{i+1}\" for i in range(6)] + [\"ALL\"])  # CH1 a CH6 primero, luego ALL\n",
    "        ctk.CTkLabel(self, text=\"Select Channel:\").grid(row=1, column=0, padx=10, pady=10)\n",
    "        self.channel_menu.grid(row=1, column=1, padx=10, pady=10)\n",
    "\n",
    "        # Etiqueta y campo de entrada para el valor del potenciómetro\n",
    "        ctk.CTkLabel(self, text=\"Amplitud Value (step):\").grid(row=0, column=2, padx=10, pady=10)\n",
    "        self.potentiometer_entry = ctk.CTkEntry(self, width=120)\n",
    "        self.potentiometer_entry.insert(0, \"255\")\n",
    "        self.potentiometer_entry.grid(row=0, column=3, padx=10, pady=10)\n",
    "\n",
    "        # Etiqueta y campo de entrada para la frecuencia\n",
    "        ctk.CTkLabel(self, text=\"Frequency (KHz):\").grid(row=1, column=2, padx=10, pady=10)\n",
    "        self.frequency_entry = ctk.CTkEntry(self, width=120)\n",
    "        self.frequency_entry.insert(0, \"80\")\n",
    "        self.frequency_entry.grid(row=1, column=3, padx=10, pady=10)\n",
    "\n",
    "        # Etiqueta y campo de entrada para el ancho de pulso\n",
    "        ctk.CTkLabel(self, text=\"Pulse Width (us):\").grid(row=2, column=2, padx=10, pady=10)\n",
    "        self.pulse_width_entry = ctk.CTkEntry(self, width=120)\n",
    "        self.pulse_width_entry.insert(0, \"200\")\n",
    "        self.pulse_width_entry.grid(row=2, column=3, padx=10, pady=10)\n",
    "\n",
    "        # Botón para enviar datos por puerto serial\n",
    "        ctk.CTkLabel(self, text=\"Channel settings:\").grid(row=2, column=0, padx=10, pady=10)\n",
    "        serial_button = ctk.CTkButton(self, text=\"Send to ESP32\", command=self.send_by_serial, fg_color=\"#4CAF50\")\n",
    "        serial_button.grid(row=2, column=1, padx=10, pady=10)\n",
    "\n",
    "        # Crear un área de texto para el monitor serial\n",
    "        self.monitor_area = ctk.CTkTextbox(self, width=600, height=200, wrap=tk.WORD)\n",
    "        self.monitor_area.grid(row=6, column=0, columnspan=6, padx=10, pady=10)\n",
    "        \n",
    "        # Botón para limpiar el monitor serial dentro del contenedor\n",
    "        button_frame = ctk.CTkFrame(self)\n",
    "        button_frame.grid(row=7, column=0, columnspan=6, padx=10, pady=10, sticky='n')\n",
    "        clear_button = ctk.CTkButton(button_frame, text=\"Clear Monitor\", command=self.clear_monitor, width=120)\n",
    "        clear_button.pack()\n",
    "        \n",
    "        # Inicializar puerto serial\n",
    "        self.serial_port = None\n",
    "        \n",
    "        # Iniciar lectura del puerto serial\n",
    "        self.after(100, self.read_serial)\n",
    "        \n",
    "    def list_ports(self):\n",
    "        \"\"\"Lista los puertos seriales disponibles.\"\"\"\n",
    "        ports = serial.tools.list_ports.comports()\n",
    "        return [port.device for port in ports]\n",
    "\n",
    "    def update_monitor(self, message):\n",
    "        \"\"\"Actualiza el monitor serial con un nuevo mensaje.\"\"\"\n",
    "        self.monitor_area.insert(tk.END, message + \"\\n\")\n",
    "        self.monitor_area.yview(tk.END)\n",
    "\n",
    "    def clear_monitor(self):\n",
    "        \"\"\"Limpia el monitor serial.\"\"\"\n",
    "        self.monitor_area.delete(\"1.0\", tk.END)\n",
    "    \n",
    "    def read_serial(self):\n",
    "        \"\"\"Lee datos del puerto serial y actualiza el monitor serial.\"\"\"\n",
    "        if self.serial_port and self.serial_port.in_waiting:\n",
    "            try:\n",
    "                line = self.serial_port.readline()\n",
    "                #print(line) #agregado\n",
    "                data = line.decode('utf-8').strip() # latino-1\n",
    "                if data:\n",
    "                    self.update_monitor(f\"ESP32 response: {data}\")\n",
    "            except UnicodeDecodeError as e:\n",
    "                self.update_monitor(f\"Error decoding data: {e}\")\n",
    "        self.after(100, self.read_serial)\n",
    "\n",
    "    def send_by_serial(self):\n",
    "        \"\"\"Envía datos por puerto serial.\"\"\"\n",
    "        port = self.selected_port.get()\n",
    "        if not port:\n",
    "            messagebox.showerror(\"Error\", \"Please select a COM port.\")\n",
    "            return\n",
    "\n",
    "        try:\n",
    "            frequency = int(self.frequency_entry.get())\n",
    "            if not (50 <= frequency <= 100):\n",
    "                messagebox.showerror(\"Error\", \"Frequency must be between 50 and 100 KHz and with a step of 1 kHz.\")\n",
    "                return\n",
    "        except ValueError:\n",
    "            messagebox.showerror(\"Error\", \"Please enter a valid numerical value for frequency.\")\n",
    "            return\n",
    "\n",
    "        try:\n",
    "            potentiometer_value = int(self.potentiometer_entry.get())\n",
    "            if not (0 <= potentiometer_value <= 255):\n",
    "                messagebox.showerror(\"Error\", \"Potentiometer value must be between 0 and 255.\")\n",
    "                return\n",
    "        except ValueError:\n",
    "            messagebox.showerror(\"Error\", \"Please enter a valid numerical value for potentiometer.\")\n",
    "            return\n",
    "\n",
    "        try:\n",
    "            pulse_width = int(self.pulse_width_entry.get())\n",
    "            if not (1 <= pulse_width <= 255):\n",
    "                messagebox.showerror(\"Error\", \"Pulse width must be between 1 and 255 us.\")\n",
    "                return\n",
    "        except ValueError:\n",
    "            messagebox.showerror(\"Error\", \"Please enter a valid numerical value for pulse width.\")\n",
    "            return\n",
    "\n",
    "        selected_channel = self.channel_var.get()\n",
    "\n",
    "        # Crear el paquete de datos\n",
    "        data_packet = {\n",
    "            'frequency': frequency,\n",
    "            'pot_value': potentiometer_value,\n",
    "            'pulse_width': pulse_width,\n",
    "            'channel': selected_channel\n",
    "        }\n",
    "\n",
    "        # Convertir a JSON y enviar\n",
    "        data_packet_json = json.dumps(data_packet) + \"\\n\"  # Añadir salto de línea para separación\n",
    "        self.update_monitor(f\"Sending data by serial port: {data_packet_json}\")\n",
    "\n",
    "        try:\n",
    "            if self.serial_port is None or not self.serial_port.is_open:\n",
    "                self.serial_port = serial.Serial(port, 9600, timeout=1)\n",
    "                time.sleep(1)  # Espera 1 segundo para que el puerto se estabilice\n",
    "                self.serial_port.flushInput()  # Limpiar el buffer de entrada\n",
    "                self.serial_port.flushOutput()  # Limpiar el buffer de salida\n",
    "                #self.serial_port.write(b'\\n')  # Enviar un byte vacío para sincronización\n",
    "            # self.serial_port.write('\\n'.encode('UTF-8')) #agregado\n",
    "            self.serial_port.write(data_packet_json.encode('UTF-8'))  # Enviar datos como bytes\n",
    "            print(\"Sending data by serial port:\", data_packet_json)\n",
    "        except serial.SerialException as e:\n",
    "            messagebox.showerror(\"Error\", f\"Failed to connect to the selected COM port: {e}\")\n",
    "\n",
    "if __name__ == \"__main__\":\n",
    "    app = SerialMonitor()\n",
    "    app.mainloop()\n",
    "\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "id": "354a1c67-cdcb-449c-87c2-6c76111f9e30",
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.9.18"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
